static char sccs_externvars_h[] = "@(#)externvars.h	1.1 10/16/90 11:03:05 LLNL ";

#include <stdio.h>
#include "defines.h"
/***********************************************************************
 * This file defines the external references to (*MOST*) of the global
 * variables for the GMAT tool
 **********************************************************************/
/* ******************************************************************** */
/*   (c) Copyright 1987 the Regents of the University of California,	*/
/*    Lawrence Livermore National Laboratory.  All Rights Reserved.	*/
/* ******************************************************************** */
 

/*
 * Copyright Cray Research, Inc.  Unpublished.	All rights reserved.

 * Cray Research warrants and provides support for this software
 * only when distributed and used under the terms of a license
 * agreement with Cray Research.

 * FOR PRODUCT DISTRIBUTED IN ANY OTHER MANNER, CRAY RESEARCH DISCLAIMS
 * ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS.  IN NO EVENT SHALL 
 * CRAY RESEARCH BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA
 * OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OF
 * THIS SOFTWARE.
*/

/* External Global Variable References */

extern int just_start;			/* 0 if first step - else 1 */
extern int first_box;
extern int dt_index;			/* offset into cd table below	*/
					/* to get name of directory	*/
extern char *directory_table[128];	/* table of filenames notice hard
					   coded max */
extern int ft_index;			/* offset into dir table below	*/
					/* to get name of trace file*/
extern int ft_val;			/* combine this with ft_index  */
extern char *file_table[128];		/* table of filenames notice hard
					     coded max */
extern int key_enable;			/* used to determine if the key can
					   be brought up in dynamic mode */
extern int done, go, filepresent;
extern int display_type;		/* 0=lock, 1=event, 2=barrier */
extern int e_speed;
extern int histx,histy;			/* Last x,y plotted in histogram */
extern int histogram_wrap;		/* Number of times histogram has wrapped */
extern int oldx,oldy;			/* coords of old view box  */
extern int choice[6];			/* user-defined significant action numbers */
extern int leftid;			/* node id of left mse bttn, -1 == invalid node */
extern int ypos;			/* global y position, according to event number */
extern double aux_data[7];		/* all possible auxiliary data */
extern double clock_interval;		/* user-set clock interval */
extern double initial_clock;		/* And then there was light */
extern double real_clock;		/* Clock as to events */
extern double last_real_clock;		/* Last Event Clock */
extern double clock_cycle;		/* One clock cycle, wrt CRAY/ALLIANT */
extern double update_time;		/* Time for one screen_update */
extern double program_clock;		       /* Clock as to DMAT */
extern int blank_intervals;		/* Number of current blank_intervals */
extern int clock_error;			/* error message flag */
extern int direction;			/* jump direction in log */
extern int jumpingFLAG;			/* whether jumping is in progress */
extern int initflag;			/* for initializing filter stacks */

extern struct screen_struct {
    int taskid;		/* id of the task in that column */
};
extern struct screen_struct screen[MAXCOLUMNS];	   /* array of screen columns */

extern int locks[MAXVALUES+1];		/* array of lock values */
extern int events[MAXVALUES+1];		/* array of event values */
extern int barriers[MAXVALUES+1];	/* array of barrier values */

extern struct task_struct {
    int x;		/* x coord of top corner of node in primary canvas */
    int process_state;	/* process assigned to task else -1 */
    int wait_state;	/* 0 if no wait, else address of what waiing on */
    int post_event;	/* action number of event, else 0 */
    int aux_item;	/* number of task, lock, event, or barrier */
    int parent;		/* task id of parent, -1 if info lost */
    double last_time_log;/* last time an event was logged */
};
extern struct task_struct  tasks[MAXTASKS];   /* array of tasks */

extern struct proc_struct {
    int state;		/* 0 = idle process
			   1 = suspended process
			   2 = reacquired process
			   3 = process bound to task
			   4 = process NOT bound to task */
    int task;		/* task process is bound to */
    int pid;		/* pid (for UNICOS, pids may be big numbers) */
    int x,y;
}; 
extern struct proc_struct procs[MAXPROCS];    /* array of process structures */

/* global variables to load socket info into */
extern int curr_id;    /* task id of current task */
extern int curr_action;	 /* action of current task */
extern int curr_process; /* process of current task */
extern int curr_events;	 /* total number of events processed */
extern int curr_procs;	 /* number of active processes */
extern int curr_tasks;	 /* total number of tasks created */

extern char node_str[40];   /* string containing node text */
extern int fp;		/* trace file descriptor */
extern FILE *df;		/* dump file */

/* filtering variables */

extern int curr_owner, curr_cs ;	/* fray filtering info */

extern double curr_clock, last_clock; /* used to check log order */
extern double idle_interval;	 /* used to guess if task is active */

extern int filter_display;	/* when =0, don't filter events; otherwise do */

extern int event_error;		/* when > 0 , event error has occurred */

extern int error_count;		/* count of event errors so far */

/* action name versus action number tables */

extern	char action_name[MAX_ACTIONS][32] ;

extern	short action_number[MAX_ACTIONS] ;

extern	char action_xname[XMAX_ACTIONS][32] ;

extern	short action_xnumber[XMAX_ACTIONS] ;

typedef struct SNAP_type {
	double real_clock;
	int curr_events;
	long file_position;
	struct proc_struct proc_table[MAXPROCS];
	struct task_struct task_table[MAXTASKS];
	struct SNAP_type *next;
} *SNAP;
extern SNAP node_root;
